unit H_PDFPages1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit2: TEdit;
    Button4: TButton;
    Button5: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Edit6: TEdit;
    Label8: TLabel;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Button3: TButton;
    Edit7: TEdit;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Edit6Exit(Sender: TObject);
    procedure Edit5Exit(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

function GetPDFText(const FileName: PChar; opt: LongInt; hw: LongInt; fast: LongInt; target: PChar; lspaces: LongInt; ptitel: PChar; pos: LongInt; page: LongInt; clock: LongInt; blank: LongInt; ende: LongInt; wlist: LongInt): PChar; stdcall;

function GetPDFPageCount(const FileName: PChar): LongInt; stdcall;

implementation

{$R *.DFM}

function GetPDFText(const FileName: PChar; opt: LongInt; hw: LongInt; fast: LongInt; target: PChar; lspaces: LongInt; ptitel: PChar; pos: LongInt; page: LongInt; clock: LongInt; blank: LongInt; ende: LongInt; wlist: LongInt): PChar; stdcall;
external 'PDFtext.dll';

function GetPDFPageCount(const FileName: PChar): LongInt; stdcall;
external 'PDFtext.dll';

procedure TForm1.Button1Click(Sender: TObject);
begin
//   RawString  := IdHTTP1.Get('http://server.de/text.txt');
//   UTF8String := @Pointer(RawString);
//   Bis Delphi 2007
//   Memo1.Text := UTF8Decode(UTF8String^);
//   Delphi 2009:
//   Memo1.Text := UTF8ToString(UTF8String^); begin
//     If OpenDialog1.Execute Then
//        Edit1.Text := OpenDialog1.FileName;
     If OpenDialog1.Execute Then
        Edit1.Text := OpenDialog1.FileName;
end;

procedure TForm1.Button2Click(Sender: TObject);
var s  : LongInt;
    pt : WideString;
    sp : LongInt; // no leading spaces
    pa : LongInt; // extract only page number ...
    po : LongInt; // with positions
    st : LongInt; // stop after ... seconds
    wl : LongInt; // result is a word-list
    hw : LongInt; // result is a hash-value
    fa : LongInt; // fast
    cl : LongInt; // sandclock on
    mp : LongInt; // no multiple spaces
begin
     if ( CheckBox1.Checked = True ) then
        sp := 1
       else
        sp := 0;

     if ( CheckBox2.Checked = True ) then
        po := 1
       else
        po := 0;

     if ( CheckBox3.Checked = True ) then
        fa := 1
       else
        fa := 0;

     if ( CheckBox4.Checked = True ) then
        cl := 1
       else
        cl := 0;

     if ( CheckBox5.Checked = True ) then
        mp := 1
       else
        mp := 0;

     if ( CheckBox6.Checked = True ) then
        wl := 1
       else
        wl := 0;

     if ( CheckBox7.Checked = True ) then
        hw := 1
       else
        hw := 0;

     if ( Trim(Edit4.Text) <> '' ) Then // pagetitle
        pt := PChar(Edit4.Text);

     if ( Trim(Edit6.Text) <> '' ) Then // stop after ... seconds
        begin
           Edit6.Text := Trim(Edit6.Text);
           st := StrToInt(Edit6.Text);
        end;

     pa := StrToInt(Trim(Edit5.Text)); // extract only page number ...

     Edit2.Text := GetPDFText(PChar(Edit1.Text), 1, hw, fa, PChar(Edit3.Text), sp, PChar(pt), po, pa, cl, mp, st, wl);

end;

procedure TForm1.Button4Click(Sender: TObject);
var s  : LongInt;
    pt : WideString;
    sp : LongInt; // no leading spaces
    pa : LongInt; // extract only page number ...
    po : LongInt; // with positions
    st : LongInt; // stop after ... seconds
    wl : LongInt; // result is a word-list
    hw : LongInt; // result is a hash-value
    fa : LongInt; // fast
    cl : LongInt; // sandclock on
    mp : LongInt; // no multiple spaces
begin
     if ( CheckBox1.Checked = True ) then
        sp := 1
       else
        sp := 0;

     if ( CheckBox2.Checked = True ) then
        po := 1
       else
        po := 0;

     if ( CheckBox3.Checked = True ) then
        fa := 1
       else
        fa := 0;

     if ( CheckBox4.Checked = True ) then
        cl := 1
       else
        cl := 0;

     if ( CheckBox5.Checked = True ) then
        mp := 1
       else
        mp := 0;

     if ( CheckBox6.Checked = True ) then
        wl := 1
       else
        wl := 0;

     if ( CheckBox7.Checked = True ) then
        hw := 1
       else
        hw := 0;

     if ( Trim(Edit4.Text) <> '' ) Then // pagetitle
        pt := PChar(Edit4.Text);

     if ( Trim(Edit6.Text) <> '' ) Then // stop after ... seconds
        begin
           Edit6.Text := Trim(Edit6.Text);
           st := StrToInt(Edit6.Text);
        end;

     pa := StrToInt(Trim(Edit5.Text)); // extract only page number ...

     Edit2.Text := GetPDFText(PChar(Edit1.Text), 2, hw, fa, PChar(Edit3.Text), sp, PChar(pt), po, pa, cl, mp, st, wl);

end;

procedure TForm1.Button5Click(Sender: TObject);
var s  : LongInt;
    pt : WideString;
    txtw : WideString;
    txtp : PChar;
    sp : LongInt; // no leading spaces
    pa : LongInt; // extract only page number ...
    po : LongInt; // with positions
    st : LongInt; // stop after ... seconds
    wl : LongInt; // result is a word-list
    hw : LongInt; // result is a hash-value
    fa : LongInt; // fast
    cl : LongInt; // sandclock on
    mp : LongInt; // no multiple spaces
begin
     if ( CheckBox1.Checked = True ) then
        sp := 1
       else
        sp := 0;

     if ( CheckBox2.Checked = True ) then
        po := 1
       else
        po := 0;

     if ( CheckBox3.Checked = True ) then
        fa := 1
       else
        fa := 0;

     if ( CheckBox4.Checked = True ) then
        cl := 1
       else
        cl := 0;

     if ( CheckBox5.Checked = True ) then
        mp := 1
       else
        mp := 0;

     if ( CheckBox6.Checked = True ) then
        wl := 1
       else
        wl := 0;

     if ( CheckBox7.Checked = True ) then
        hw := 1
       else
        hw := 0;

     if ( Trim(Edit4.Text) <> '' ) Then // pagetitle
        pt := PChar(Edit4.Text);

     if ( Trim(Edit6.Text) <> '' ) Then // stop after ... seconds
        begin
           Edit6.Text := Trim(Edit6.Text);
           st := StrToInt(Edit6.Text);
        end;

     pa := StrToInt(Trim(Edit5.Text)); // extract only page number ...

     if ( hw = 0 ) and ( pa = 0 ) Then
        begin
           Edit7.Text := IntToStr(GetPDFPageCount(PChar(Edit1.Text)));
           if ( StrToInt(Edit7.Text) > 25 ) and ( StrToInt(Edit7.Text) < 9000 ) Then
              begin
                 ShowMessage('This sample will put the returning content into' + #10#13 +
                             'a TEdit-field - this does not make really sense' + #10#13 +
                             'cause there are more than 25 pages here ...' + #10#13 +
                             'In your own applications you should use a memo-' + #10#13 +
                             'field or something similar.');
                 Edit2.Text := '';
                 Exit;
              end;
        end;
     Edit2.Text := GetPDFText(PChar(Edit1.Text), 3, hw, fa, PChar(Edit3.Text), sp, PChar(pt), po, pa, cl, mp, st, wl);

end;

procedure TForm1.Edit6Exit(Sender: TObject);
begin
     If ( StrToInt(Trim(Edit6.Text) ) > 1800 ) or
        ( StrToInt(Trim(Edit6.Text) ) < 0 )     Then
        Edit6.Text := '0';
end;

procedure TForm1.Edit5Exit(Sender: TObject);
begin
     If ( StrToInt(Trim(Edit5.Text) ) > 99999 ) or
        ( StrToInt(Trim(Edit5.Text) ) < 0 )     Then
        Edit5.Text := '0';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   Edit7.Text := IntToStr(GetPDFPageCount(PChar(Edit1.Text)));
end;

end.
